<?php

namespace Drupal\commerce_icici_pay;

class IciciUtility {

	// Function to generate hmac secure hash in hex format
	function hmacDigest($inputString, $keyString) {
	    return hash_hmac('sha256', $inputString, $keyString);
	}

	// Function to validate securehash recieved
	function validateSecureHash($req, $keyString) {
	    $request = $req;
	    unset($request['secureHash']);
	    ksort($request);
	    $hashString = '';
	    foreach ($request as $key => $value) {
	      $hashString .= $value;
	    }
	    $secureHash = $this->hmacDigest($hashString, $keyString);
	    if ($secureHash == $req['secureHash']) {
	    	return true;
	    }
	    else {
	    	return false;
	    }
	}

	// Function to hit Post API using cURL
	function curlPostApi($api, $data) {
	    $dataJson = json_encode($data);
	    $ch = curl_init($api);
	    if ($ch == false) {
	        return false;
	    }
	    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, $dataJson);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
	    curl_setopt($ch, CURLOPT_SSLVERSION, 6);
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
	    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
	    curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
	    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	    $response = curl_exec($ch);
		curl_close($ch);

		return json_decode($response);
	}
}
?>